import socket
import time
import os

# Definition
file_path = 'textout.txt'
tcp_ip = '127.0.0.1'
tcp_port = 8001

with open(file_path, 'w') as f:
    pass

server_socket = socket.socket(socket.AF_INET, socket.SOCK_STREAM)

server_socket.bind((tcp_ip, tcp_port))

server_socket.listen(1)
print(f"Server running and \033[93mwaiting\033[0m for incoming TCP connection on {tcp_ip}:{tcp_port}...")

client_socket, client_address = server_socket.accept()
print(f"Connection from client \033[92maccepted\033[0m.")

try:
    last_size = 0
    buffer = ''

    while True:
        current_size = os.path.getsize(file_path)

        if current_size > last_size:
            with open(file_path, 'r', encoding='utf-8', errors='ignore') as f:
                f.seek(last_size)
                new_data = f.read()

            filtered_data = ''.join(new_data.split())
            buffer += filtered_data

            print(filtered_data, end='', flush=True)

            while len(buffer) >= 54:

                modified_buffer = ''.join(c if c in '0123456789ABCDEFHI' else '*' for c in buffer)

                if (modified_buffer[:4] == "HIHI" and 
                  all(c not in 'HI' for c in modified_buffer[4:50]) and 
                  len(modified_buffer[4:50]) == 46 and 
                  modified_buffer[50:54] == "HIHI"):

                  message_to_send = modified_buffer[4:50]

                  client_socket.send(f"HIHI{message_to_send}".encode())

                  print(f"\n\033[92mUploaded:\033[0m HIHI{message_to_send}")

                buffer = buffer[1:]
            last_size = current_size

        time.sleep(0.1)

except KeyboardInterrupt:
    print("\nQuit")
finally:
    client_socket.close()
    server_socket.close()